<?php

namespace SIU\SQ\Lib\daos;

use SIU\SQ\Lib\errores\error_negocio;

class dao_comprobantes extends dao
{
	function get_lista($filtro = [], $order_by = "ORDER BY id", $limit = "")
	{
		$where = "";
		if(isset($filtro['id'])) {
			$where .= " AND id = " . $this->quote($filtro['id']);
		}
		if(isset($filtro['id_comprobante_template'])) {
			$where .= " AND id_comprobante_template = " . $this->quote($filtro['id_comprobante_template']);
		}
        if(isset($filtro['id_punto_cobranza'])) {
            $where .= " AND id_punto_cobranza = " . $this->quote($filtro['id_punto_cobranza']);
        }
		if(isset($filtro['estado'])) {
			$where .= " AND estado = " . $this->quote($filtro['estado']);
		}
		if(isset($filtro['numero_comprobante'])) {
			$where .= " AND numero_comprobante = " . $this->quote($filtro['numero_comprobante']);
		}

		$sql = "SELECT
					comp.id,
					comp.id_comprobante_template,
					comp.presentacion,
       				comp.importe_control,
					comp.id_rdi,
					comp.numero_comprobante,
       				comp.id_comprobante_relacionado,
       				comp.estado,
       				comp.estado_actualizado_en,
       				comp.id_punto_cobranza,
       				(SELECT vip.datos FROM ventas_info_personalizada vip
       				                  JOIN cobranzas_ventas cv ON cv.id_venta = vip.id_venta
       				                  JOIN cobranzas c ON cv.id_cobranza = c.id AND c.id_comprobante = comp.id
                    ) as ventas_info_personalizada
				FROM
					comprobantes comp
				WHERE 1=1
					$where $order_by $limit;";
		return $this->entorno()->db()->consultar($sql);
	}

	function get($id)
	{
		$rs = $this->get_lista(['id' => $id]);
		if(count($rs) == 1){
			return $rs[0];
		}else{
			if(count($rs) > 1){
				throw new error_negocio("DAO_COMPROBANTES: "
						. "La consulta devuelve mas de un registro.");
			}else{
				return null;
			}
		}
	}

	function get_lista_templates($filtro = [], $order_by = "ORDER BY ct.id", $limit = "")
	{
		$where = "";
		if(isset($filtro['id'])) {
			$where .= " AND ct.id = " . $this->quote($filtro['id']);
		}
		if(isset($filtro['codigo'])) {
			$where .= " AND ct.codigo = " . $this->quote($filtro['codigo']);
		}
		if(isset($filtro['descripcion'])) {
			$where .= " AND ct.descripcion = " . $this->quote($filtro['descripcion']);
		}
		if(isset($filtro['estado'])) {
			$where .= " AND ct.estado = " . $this->quote($filtro['estado']);
		}

		$sql = "SELECT
					ct.id,
					ct.codigo,
					ct.descripcion,
					ct.tipo_comprobante,
					ct.modelo,
					ct.numeracion,
					ct.numeracion_externa,
					ct.estado,
					ct.estado_actualizado_en,
					ct.id_arai,
					ct.revision,
					ct.sincronizar
				FROM
					comprobantes_templates ct
				WHERE 1 = 1
					$where
				$order_by $limit";
		return $this->entorno()->db()->consultar($sql);
	}

	function get_template($id)
	{
		$rs = $this->get_lista_templates(['id' => $id]);
		if(count($rs) == 1){
			return $rs[0];
		}else{
			if(count($rs) > 1){
				throw new error_negocio("DAO_COMPROBANTES: "
						. "La consulta devuelve mas de un registro.");
			}else{
				return null;
			}
		}
	}

    function get_parametrizaciones() {
        $sql = "
            SELECT
                p.id,  
                p.institucion,
                p.institucion_direccion,
                p.institucion_cuit,
                p.institucion_posicion_fiscal,
                p.institucion_telefono,
                p.institucion_posicion_iibb,
                p.institucion_inicio_actividad,
                p.comprobante_tipo_factura,
                p.comprobante_tipo_nota_credito,
                p.comprobante_tipo_letra,
                p.comprobante_leyenda_pie

            FROM
                comprobantes_templates_parametrizaciones p
            LIMIT 1
	    ";

        return $this->entorno()->db()->consultar_fila($sql);

    }
}
